using System;
using System.Collections.Specialized;
using System.Configuration;
using System.IO;
using System.Net;
using System.Security.Principal;
using System.Text;
using ITHit.WebDAV.Server;

namespace WebDAVServer.DeltaV
{
    internal class WDRequest : Request
    {
        private HttpListenerRequest fRequest;
        private IPrincipal fUser;
        private NameValueCollection form = new NameValueCollection();

        public WDRequest(HttpListenerRequest request, IPrincipal user)
        {
            this.fRequest = request;
            this.fUser = user;
        }

        public IPrincipal User
        {
            get { return fUser; }
        }

        #region Request Implementation

        public override string ApplicationPath
        {
            get
            {
                string uriPrefix = ConfigurationManager.AppSettings["ListenerPrefix"];

                int i = uriPrefix.IndexOf("://");
                i = uriPrefix.IndexOf('/', i + 3);

                return uriPrefix.Substring(i);
            }
        }

        public override Encoding ContentEncoding
        {
            get { return fRequest.ContentEncoding; }
        }

        public override long ContentLength
        {
            get { return (int) fRequest.ContentLength64; }
        }

        public override string ContentType
        {
            get { return fRequest.ContentType; }
        }

        public override NameValueCollection Headers
        {
            get { return fRequest.Headers; }
        }

        public override string HttpMethod
        {
            get { return fRequest.HttpMethod; }
        }

        public override Stream InputStream
        {
            get
            {
                return fRequest.InputStream;                
            
            }
        }

        public override Uri Url
        {
            get { return fRequest.Url; }
        }

        public override string UserAgent
        {
            get{ return fRequest.UserAgent; }
        }

        public override NameValueCollection Form
        {
            get { return form; }
        }

        #endregion // Request Implementation
    }
}