using System.IO;
using System.Net;
using System.Text;
using ITHit.WebDAV.Server;

namespace WebDAVServer.DeltaV
{
    public class WDResponse : IResponse
    {
        private HttpListenerResponse fResponse;

        public WDResponse(HttpListenerResponse response)
        {
            this.fResponse = response;
        }

        #region IResponse Members

        public void AddHeader(string name, string value)
        {
            fResponse.AddHeader(name, value);
        }

        public Encoding ContentEncoding
        {
            set { fResponse.ContentEncoding = value; }
        }

        public string ContentType
        {
            set { fResponse.ContentType = value; }
        }

        public long ContentLength
        {
            set { fResponse.ContentLength64 = value; }
        }

        public Stream OutputStream
        {
            get { return fResponse.OutputStream; }
        }

        public int StatusCode
        {
            get { return fResponse.StatusCode; }
            set { fResponse.StatusCode = value; }
        }

        public string StatusDescription
        {
            set { fResponse.StatusDescription = value; }
        }

        public void Clear()
        {
            // workaround of litmus/neon WebDAV client library bug
            fResponse.SendChunked = false; // could be commented out for any other WebDAV client
        }

        #endregion // IResponse Members
    }
}