using System.Configuration;
using System.IO;
using ITHit.WebDAV.Server;

namespace WebDAVServer.FileSystemListenerService
{
	public class WDEngine : Engine
    {
        #region Engine Members Override

        public override IHierarchyItem GetHierarchyItem(string path)
        {
            string discPath = ConfigurationManager.AppSettings["StorageRootFolder"].TrimEnd('\\');
            discPath += path.Replace('/', '\\');
            
            DirectoryInfo directory = new DirectoryInfo(discPath);
            if(directory.Exists)
                return new Folder(directory);
            else
            {
                FileInfo file = new FileInfo(discPath);
                if(file.Exists)
                {
                    if ( (file.Attributes & FileAttributes.Temporary) != 0)
                        return new LockNull(file); // lock-null item
                    else
                        return new Resource(file);
                }
            }
            return null;
        }

        #endregion // Engine Members Override
    }
}
