using System;
using System.Web;
using System.IO;
using System.Text;
using System.Collections.Specialized;
using ITHit.WebDAV.Server;
using ITHit.WebDAV.Server.ResumableUpload;

namespace WebDAVServer.IisResumable
{
    public class WDRequest : Request
    {
        private readonly NameValueCollection form = new NameValueCollection();

        public override Uri Url
        {
            get { return HttpContext.Current.Request.Url; }
        }

        public override string ApplicationPath
        {
            get { return HttpContext.Current.Request.ApplicationPath; }
        }

        public override string HttpMethod
        {
            get { return HttpContext.Current.Request.HttpMethod; }
        }
        
        public override NameValueCollection Headers
        {
            get { return HttpContext.Current.Request.Headers; }
        }
        
        public override string ContentType
        {
            get { return HttpContext.Current.Request.ContentType; }
        }
        
        public override Encoding ContentEncoding
        {
            get { return HttpContext.Current.Request.ContentEncoding; }
        }
        
        public override long ContentLength
        {
            get { return HttpContext.Current.Request.ContentLength; }
        }
		
        public override Stream InputStream
        {
            get { return UploadContext.IsAvailable ? UploadContext.GetStream() : HttpContext.Current.Request.InputStream; }
        }

        public override string UserAgent
        {
            get
            {
                return HttpContext.Current.Request.UserAgent;
            }
        }


        public override NameValueCollection Form
        {
            get { return form; }
        }
    }
}
