using System.IO;
using System.Text;
using System.Web;
using ITHit.WebDAV.Server;

namespace WebDAVServer.IisResumable
{
	public class WDResponse : IResponse
	{
	    private bool contentLengthSet = false;
        public int StatusCode
        {
			get { return HttpContext.Current.Response.StatusCode; }
            set { HttpContext.Current.Response.StatusCode = value; }
        }

        public string StatusDescription
        {
            set { HttpContext.Current.Response.StatusDescription = value; }
        }

		public Encoding ContentEncoding
		{
			set { HttpContext.Current.Response.ContentEncoding = value; }
		}

        public string ContentType
        {
            set { HttpContext.Current.Response.ContentType = value; }
        }

		public long ContentLength
		{
			set 
            {
                if (!contentLengthSet) // Silverlight 1.1 Alpha will fail to parse headers if added more than once.
                    HttpContext.Current.Response.AppendHeader("Content-Length", value.ToString());
                contentLengthSet = true;
            }
		}

        public void AddHeader(string headerName, string headerValue)
        {
            HttpContext.Current.Response.AppendHeader(headerName, headerValue);
        }

        public Stream OutputStream
        {
            get { return HttpContext.Current.Response.OutputStream; }
        }
		public void Clear()
		{
		}
    }
}
