using System;
using System.Configuration;
using System.Web;
using ITHit.WebDAV.Logger;

namespace WebDAVServer.IisResumable
{
    public class WebDAVHandler : IHttpHandler
    {
        private static
            bool autoPutUnderVersionControl =
                Convert.ToBoolean(ConfigurationManager.AppSettings["AutoPutUnderVersionControl"]);

        public void ProcessRequest(HttpContext context)
        {
			context.Response.BufferOutput = false;

			FileLogger.Level = LogLevel.Debug;
			FileLogger.LogFile = context.Request.PhysicalApplicationPath + "WebDAVlog.txt";

			WDEngine engine = new WDEngine();
            WDResponse response = new WDResponse();
            WDRequest request = new WDRequest();

            // set custom handler to process GET requests to folders and display info about how to connect to server
            MyCustomGetHandler handler = new MyCustomGetHandler();
            handler.OriginalHandler = engine.RegisterMethodHandler("GET", handler);
            engine.IgnoreExceptions = false;
            engine.AutoPutUnderVersionControl = autoPutUnderVersionControl;

            //engine.Run(request, response);
            try
            {
                engine.Run(request, response);
                engine.CommitTransaction();
            }
            catch
            {
                engine.RollBackTransaction();
            }
            finally
            {
                engine.CloseConnection();
            }
        }

        public bool IsReusable
        {
            get { return true; }
        }
    }
}
