using System.Web;
using ITHit.WebDAV.Logger;

namespace WebDAVServer.SqlStorage
{
    public class WebDAVHandler : IHttpHandler
    {
        #region IHttpHandler Members

        public void ProcessRequest(HttpContext context)
        {
            context.Response.BufferOutput = false;

            FileLogger.Level = LogLevel.Debug;
            FileLogger.LogFile = context.Request.PhysicalApplicationPath + "WebDAVlog.txt";

            WDEngine engine = new WDEngine();
            WDRequest request = new WDRequest();
            WDResponse response = new WDResponse();

            // set custom handler to process GET requests to folders and display info about how to connect to server
            MyCustomGetHandler handler = new MyCustomGetHandler();
            handler.OriginalHandler = engine.RegisterMethodHandler("GET", handler);

            engine.Run(request, response);
        }

        public bool IsReusable
        {
            get { return true; }
        }

        #endregion // IHttpHandler Members
    }
}
